# Présentation

[Visual Studio Code ou VS Code](https://code.visualstudio.com/) est un IDE édité par Microsoft, s'appuyant sur la librairie [Monaco](https://microsoft.github.io/monaco-editor/) également utilisée dans Vitis. \
C'est une application développée avec électron, d'ailleurs une [version Web](https://vscode.dev/) existe aussi qui peut parfois dépanner sur les serveurs Windows.

## Configuration

Pour accéder au fichier de configuration JSON de vscode Il faut passer par la palette de commande `CTRL+MAJ+P` et choisir `Preferences : Open User Settings (JSON)`.

Configuration conseillée par défaut : 
```json
{
    "files.associations": {
        "*.inc": "php"
    },
    "editor.tabSize": 2,
    "editor.formatOnPaste": false,
    "typescript.updateImportsOnFileMove.enabled": "always",
    "javascript.updateImportsOnFileMove.enabled": "always",
    "[javascript]": {
        "editor.defaultFormatter": "vscode.typescript-language-features"
    },
    "[scss]": {
        "editor.defaultFormatter": "vscode.css-language-features"
    },
    "[json]": {
        "editor.defaultFormatter": "vscode.json-language-features"
    },
    "[typescript]": {
        "editor.defaultFormatter": "vscode.typescript-language-features"
    },
    "[php]": {
        "editor.defaultFormatter": "kokororin.vscode-phpfmt"
    },
    "[jsonc]": {
        "editor.defaultFormatter": "vscode.json-language-features"
    },
    "[html]": {
        "editor.defaultFormatter": "vscode.html-language-features"
    },
    "[css]": {
        "editor.defaultFormatter": "vscode.css-language-features"
    },
}
```

Configuration complète (avec toutes les extensions)

```json
{
    "files.associations": {
        "*.inc": "php"
    },
    "editor.tabSize": 2,
    "editor.formatOnPaste": false,
    "editor.multiCursorModifier": "ctrlCmd",
    "typescript.updateImportsOnFileMove.enabled": "always",
    "javascript.updateImportsOnFileMove.enabled": "always",
    "[javascript]": {
        "editor.defaultFormatter": "vscode.typescript-language-features"
    },
    "[scss]": {
        "editor.defaultFormatter": "vscode.css-language-features"
    },
    "[json]": {
        "editor.defaultFormatter": "vscode.json-language-features"
    },
    "[typescript]": {
        "editor.defaultFormatter": "vscode.typescript-language-features"
    },
    "[php]": {
        "editor.defaultFormatter": "kokororin.vscode-phpfmt"
    },
    "[jsonc]": {
        "editor.defaultFormatter": "vscode.json-language-features"
    },
    "[html]": {
        "editor.defaultFormatter": "vscode.html-language-features"
    },
    "[css]": {
        "editor.defaultFormatter": "vscode.css-language-features"
    },
    "phpfmt.psr1": true,
    "phpfmt.psr2": false,
    "phpfmt.detect_indent": false,
    "phpfmt.indent_with_space": 2,
    "phpfmt.php_bin": "/var/lib/php-7.4.5/bin/php",
    "phpfmt.passes": [
        "ReindentSwitchBlocks",
        "PSR2KeywordsLowerCase",
        "PSR2LnAfterNamespace",
        "PSR2EmptyFunction",
        "PSR2SingleEmptyLineAndStripClosingTag",
        "StripNewlineAfterClassOpen",
        "StripNewlineAfterCurlyOpen",
        "ShortArray",
        "EliminateDuplicatedEmptyLines",
        "ExtraCommaInArray",
        "AutoSemicolon",
        "AlignTypehint"
    ],
    "phpfmt.exclude": [
        "PSR2CurlyOpenNextLine"
    ],
    "sftp.downloadWhenOpenInRemoteExplorer": true,
}
```