# Configuration additionel pour GTF

Dans le cas des infogérances, Veremes prend en charge des configurations supplémentaires de façon à éviter des remontés systématique au support.

Certains points sont à soumettre au client en amont de l'installation, intervention, car il devra protentiellement fournir des éléments ou confirmer qu'il ne souhaite pas qu'on fasse ces manipulations pour l'instant.

Cette section considère que l'installation/mis eà jour a été effectué en suivant la documentation de GTF et que tout est déjà dans le même état qu'une application on-premise bien installée.

## Création des moteurs FME et GTF souhaité par le client

[Lien vers la doc de l'application](http://documentation.veremes.net/gtf/fr/installation/installation.html#configuration-de-gtf)

## Mise en place d'un certificat SSL fonctionnel

Il faut pouvoir fournir un certificat valide à minima un let's encrypt.
Ce point est à valider avec le client qui peut s'en passer s'il le souhaite ou nous fournir son certificat s'il en a un.

## Configuration du SMTP

Si le client a déjà un service SMTP accessible depuis l'application alors il faut l'ajouter, sinon il faut lui chiffrer l'utilisation du service SES sur son compte et l'activer sur le serveur.

L'activation du SMTP est à confirmer avec le client il peut aussi s'en passer.

## Configuration des chemins vers les ressources partagées

Il faut jouer ce script systématiquement : 

```sh
cd /var/www
sudo mkdir .Safe\ Software
sudo mkdir .fme
cd .Safe\ Software
sudo mkdir FME
cd /var/www/.fme
sudo mkdir Formats
sudo mkdir Transformers
cd /var/www
sudo chown -R www-data.www-data .Safe\ Software
sudo chmod 755 -R .Safe\ Software
sudo chown -R www-data.www-data .fme
sudo chmod 755 -R .fme
```

Ensuite il faut définir la configuration dans l'application comme suit : 
![ressources partagées conf](./images/shared_ressource_fme.png)

Dans le cas d'un serveur Windows il suffit de se référer à ce qui est écrit dans le log d'un traitement FME, vous pouvez lancer [1Minute.fmw](http://documentation-dev.veremes.net/dev/fr/_static/exploitation/1minute.fmw) si besoin.

## Configuration du template par défaut

Par défaut lors de l'installation le template par défaut n'est pas le dernier c'est bien de définir le dernier et de fair eun coup de tri dans la liste.

![mail template conf](./images/mail_template.png)

## Configuration du fuseau horaire

Pour vérifier que c'est bien configuré il suffit de regarder la date de dernière connexion de votre compte, si c'est dans le futur alors il faut aller dans la configuration et passer le champ sur la valeur `UTC`.

![timezone conf](./images/timezone_conf.png)

# Tests de fonctionnement

Dans la logique il faudrait réaliser la quasi totalité de ces action avant et aprés une mise à jour pour vérifier la non regression de l'application.

Si c'est lancé aprés ce sera déjà pas mal.

## Vérification de la publication

Ajout de [1Minute.fmw](http://documentation-dev.veremes.net/dev/fr/_static/exploitation/1minute.fmw) dans l'application.

Il faut ensuite vérifier que le parser à bien réussi à génére run formulaire et extraire les métadonnées

## Vérification du fonctionnement du moteur

Faire la gestion des droit sur le projet précédemment ajouté, puis lancer une demande sur ce traitement.

Si le traitement se lance (peu importe l'état résultat à cause du python) c'est ok.

## Vérification de l'envoi de mail

Suite à la demande il faut vérifier si un mail a bien été envoyé, si un mail est présent sur le compte il suffit d'aller vérifier sa boite mail, sinon un coup d'oeil dans le fichier notify.log fera l'affaire.

## Vérification de la configuration des moteurs

Il y a quelques configuration spécifique qui sont parfois perdues pendant les mises à jour.

Il faut aller vérifier dans /var/www/gtf/vas/engine/**/conf/ si les fichier json n'ont pas de différences inquiétantes.

Configuration debian pour les impressions/générations de mails par exemple.

Un fois dans le dossier, c'est bien de jeter un oeil sur le jobs.json pour vérifier que tout ce qui doit être là y est :
- engine startOrder
- engine checkOrder
- engine startInstance
- engine stopInstance
- un runAutomations par période
- un wfRunTriggers par période
- engine wfRunIterationTasks
- exploitationService cleanFiles

## Connexion base Oracle

Si l'appli est connecté à une base oracle, il faudra réactiver l'extension dans le php.ini.
